<?php
add_action( 'customize_register', 'explora_customizer' );
function explora_customizer( $wp_customize ) {
	wp_enqueue_style('explora-customizr', get_template_directory_uri() .'/css/customizr.css');
	$explora_theme_options = explora_get_options();	
	/* Genral section */
	$wp_customize->add_panel( 'explora_theme_option', array('title' => __( 'Theme Options','explora' ), 'priority' => 1) );
	//changelog//	
	$wp_customize->add_section('changelog_sec',	array('title' =>  __( 'Changelog','explora' ),
			'panel'=>'explora_theme_option',
            'priority' => 1,
    ));
	$wp_customize->add_setting( 'changelog', array(
			'default'    		=> null,
			'sanitize_callback' => 'sanitize_text_field',
	));
	$wp_customize->add_control( new explora_changelog_Control( $wp_customize, 'changelog', array(
			'label'    => __( 'Explora', 'explora' ),
			'section'  => 'changelog_sec',
			'settings' => 'changelog',
			'priority' => 1,
	)));
	
	// For Slider Settings	
	$wp_customize->add_section('slider_sec',	array('title' =>  __( 'Theme Slider Options','explora' ),
			'panel'=>'explora_theme_option',
            'description' => __('Here you can manage slider','explora'),
			'capability'=>'edit_theme_options',
            'priority' => 35,
    ));
	
	$wp_customize->add_setting('explora_sliders', array(
		'capability' => 'edit_theme_options',
		'sanitize_callback' => 'themeslug_sanitize_select',
		'default' => '1',
		) );
	$wp_customize->add_control( 'explora_sliders', array(
		'label'        => __( 'Set Your Home Slider', 'explora' ),
		'description' => 'You can only set slider 1 or 2',
		'type'=>'select',
		'choices' => array(
			'1' => __( 'Slider 1', 'explora' ),
			'2' => __( 'Slider 2', 'explora' )),
		'section'    => 'slider_sec',
	) );
		
	$wp_customize->add_setting('explora_options[explora_slider]', 
		array('default'=>esc_attr($explora_theme_options['explora_slider']),
			'sanitize_callback'=>'explora_sanitize_checkbox',
			'capability'        => 'edit_theme_options',
		));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_slider]', array(
	'selector' => '.explora_options_slider',
	'render_callback' => 'explora_options[explora_slider]',
	) );
		
	$wp_customize->add_control( 'explora_slider', array('label'=> __( 'Show Slider on Home Page', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'slider_sec',
		'settings'   => 'explora_options[explora_slider]',
	));
		
	for($i=1; $i<=3; $i++){
		$wp_customize->add_setting('explora_options[slide_image_'.$i.']', array('default'=>'','capability' => 'edit_theme_options', 'sanitize_callback'=>'explora_sanitize_integer'));
		$wp_customize->add_control(	
		new Slider_Image_Control($wp_customize,'slide_image_'.$i, array('label'=>'Slider Image '.$i, 'section'=>'slider_sec', 'settings' => 'explora_options[slide_image_'.$i.']')) 
		);
	}

	$wp_customize->selective_refresh->add_partial( 'blogname', array(
	'selector' => '.logo h1',
	'render_callback' => 'blogname',
	) );
	$wp_customize->selective_refresh->add_partial( 'blogdescription', array(
	'selector' => '.site-description',
	'render_callback' => 'blogdescription',
	) );
	
	$wp_customize->add_setting(
		'explora_options[slider_speed]',
		array(
			'default'=>$explora_theme_options['slider_speed'],
			'sanitize_callback'=>'explora_sanitize_text',
			'capability'        => 'edit_theme_options',
		)
	);
	
	$wp_customize->add_control( new Customizer_Range_Value_Control( $wp_customize, 'slider_speed', array(
	'type'     => 'range-value',
	'section'  => 'slider_sec',
	'settings' => 'explora_options[slider_speed]',
	'label'    =>  __( 'Slider Speed Option', 'explora' ),
	'description'=>esc_html__('Select slider speed', 'explora' ),
	'input_attrs' => array(
		'min'    => 2000,
		'max'    => 9000,
		'step'   => 1000,
		'suffix' => 'px', //optional suffix
  	),
	)));
	
	// For Service Section
	$wp_customize->add_section('service_section', array(	'title'=>__("Home Service Options",'explora'),	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));
	
	$wp_customize->add_setting('explora_options[explora_services]',
		array('default'=>esc_attr($explora_theme_options['explora_services']),
			'sanitize_callback'=>'explora_sanitize_checkbox',
			'capability'        => 'edit_theme_options',
		));

	$wp_customize->add_control( 'explora_services', array(
		'label'        => __( 'Show Services on Home Page', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'service_section',
		'settings'   => 'explora_options[explora_services]',
	) );
	
	$wp_customize->add_setting(
	'explora_options[explora_service_heading]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_service_heading']),
		'sanitize_callback'=>'explora_sanitize_text',
		'capability'=>'edit_theme_options'
		));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_service_heading]', array(
	'selector' => '.explora_services_title',
	'render_callback' => 'explora_options[explora_service_heading]',
	));
	$wp_customize->add_control( 'explora_service_heading', array(
		'label'        =>  __('Home Service Title', 'explora' ),
		'description'=>esc_html__('Enter Service section heading', 'explora' ),
		'type'=>'text',
		'section'    => 'service_section',
		'settings'   => 'explora_options[explora_service_heading]'
	));
	
	$wp_customize->add_setting('explora_options[explora_service_desc]',	array(
	'default'=>esc_attr($explora_theme_options['explora_service_desc']),
	'sanitize_callback'=>'explora_sanitize_text',	
	'capability'=>'edit_theme_options'
	));
	
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_service_desc]', array(
	'selector' => '.explora_services_desc',
	));
	
	$wp_customize->add_control('explora_service_desc', array(
		'type'=>'textarea',
		'label'        => __( 'Home Service Description', 'explora' ),
		'description'=>esc_html__('In Service Description you can use html tag like <h1> Latest Service </h1>', 'explora' ),
		'section'    => 'service_section',
		'settings'   => 'explora_options[explora_service_desc]'
	));
	
	
	for($i=1; $i<=3; $i++){
	$wp_customize->add_setting('explora_options[ser_img_'.$i.']',array(	'default'=>'','capability' => 'edit_theme_options',	'sanitize_callback'=>'explora_sanitize_integer'));
	$wp_customize->add_control( new Slider_Image_Control( $wp_customize, 'ser_img_'.$i,	array('label'=> 'Service Image '.$i, 'section'=>'service_section','settings'=>'explora_options[ser_img_'.$i.']')));
	}

	/* Portfolio Options */
	$wp_customize->add_section('explora_port_section',array(
	'title'=>__("Home Portfolio Options",'explora'),
	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));
	$wp_customize->add_setting(
		'explora_options[explora_portfolio]',
		array(
			'default'=>esc_attr($explora_theme_options['explora_portfolio']),
			'sanitize_callback'=>'explora_sanitize_checkbox',
			'capability'        => 'edit_theme_options',
	));
	$wp_customize->add_control( 'explora_portfolio', array(
		'label'        => __( 'Show Portfolio on Home Page', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'explora_port_section',
		'settings'   => 'explora_options[explora_portfolio]',
	));
	$wp_customize->add_setting(
	'explora_options[explora_portfolio_heading]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_portfolio_heading']),
		'sanitize_callback'=>'explora_sanitize_text',
		'capability'=>'edit_theme_options'
		));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_portfolio_heading]', array(
	'selector' => '.explora_portfolio_title',
	));
	$wp_customize->add_control( 'explora_portfolio_heading', array(
		'label'        =>  __('Home Portfolio Title', 'explora' ),
		'description'=>esc_html__('Enter portfolio section heading', 'explora' ),
		'type'=>'text',
		'section'    => 'explora_port_section',
		'settings'   => 'explora_options[explora_portfolio_heading]'
	));
	$wp_customize->add_setting( 'explora_options[explora_portfolio_desc]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_portfolio_desc']),
		'sanitize_callback'=>'explora_sanitize_text',
		'capability'=>'edit_theme_options'
	));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_portfolio_desc]', array(
	'selector' => '.explora_portfolio_desc',
	));
	
	$wp_customize->add_control('explora_portfolio_desc', array(
		'type'=>'textarea',
		'label'        => __( 'Home Portfolio Description', 'explora' ),
		'description'=>esc_html__('In Portfolio Description you can use html tag like <h1> Latest Portfolio </h1>', 'explora' ),
		'section'    => 'explora_port_section',
		'settings'   => 'explora_options[explora_portfolio_desc]'
	));
	$wp_customize->add_setting(
		'explora_options[portfolio_category]',
			array(
			'default'=>'',
			'sanitize_callback'=>'explora_sanitize_text',
			'capability'        => 'edit_theme_options',
	));
	$wp_customize->selective_refresh->add_partial( 'explora_options[portfolio_category]', array(
	'selector' => '.explora_portfolio_category',
	));

	$wp_customize->add_control( 
		new explora_category_Control( 
		$wp_customize, 'portfolio_category',
		array(
		'label'    => 'Portfolio Category', 
		'section'  => 'explora_port_section',
		'settings' => 'explora_options[portfolio_category]',
	)));
	
	// For Home Blog Section
	$wp_customize->add_section('explora_blog_section',array(
	'title'=>__("Home Blog Options",'explora'),
	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));
	$wp_customize->add_setting(
		'explora_options[explora_blog]',
		array(
			'default'=>esc_attr($explora_theme_options['explora_blog']),
			'sanitize_callback'=>'explora_sanitize_checkbox',
			'capability'        => 'edit_theme_options',
		)
	);
	$wp_customize->add_control( 'explora_blog', array(
		'label'        => __( 'Show Blog on Home Page', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'explora_blog_section',
		'settings'   => 'explora_options[explora_blog]',
	));
	
	$wp_customize->add_setting(
		'explora_options[explora_blog_title]',
		array(
			'default'=>esc_attr($explora_theme_options['explora_blog_title']),
			'capability' => 'edit_theme_options',
			'sanitize_callback'=>'explora_sanitize_text',
	));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_blog_title]', array(
	'selector' => '.explora_blog_title',
	));
	$wp_customize->add_control( 'explora_blog_title', array(
		'label'        => __('Home Blog Heading', 'explora' ),
		'description'=>esc_html__('Enter Blog section heading', 'explora' ),
		'type'=>'text',
		'section'    => 'explora_blog_section',
		'settings'   => 'explora_options[explora_blog_title]'
	));
	$wp_customize->add_setting(
		'explora_options[explora_blog_desc]',
		array(
			'default'=>esc_attr($explora_theme_options['explora_blog_desc']),
			'capability' => 'edit_theme_options',
			'sanitize_callback'=>'explora_sanitize_text',
	));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_blog_desc]', array(
	'selector' => '.explora_blog_desc',
	));
	$wp_customize->add_control('explora_blog_desc', array(
		'type'=>'textarea',
		'label'        => __('Home Blog Description', 'explora' ),
		'description'=>esc_html__('In Blog Description you can use html tag like <h1> Latest Blogs </h1>', 'explora' ),
		'section'    => 'explora_blog_section',
		'settings'   => 'explora_options[explora_blog_desc]'
	));
	$wp_customize->add_setting(
		'explora_options[blog_preview]',
		array(
			'default'=>$explora_theme_options['blog_preview'],
			'sanitize_callback'=>'explora_sanitize_text',
			'capability'        => 'edit_theme_options',
		)
	);

	$wp_customize->add_control( new Customizer_Range_Value_Control( $wp_customize, 'blog_preview', array(
	'type'     => 'range-value',
	'section'  => 'explora_blog_section',
	'settings'   => 'explora_options[blog_preview]',
	'label'        => __( 'Blog Preview Option', 'explora' ),
	'description'=>esc_html__('Select number of blog preview', 'explora' ),
	'input_attrs' => array(
		'min'    => 2,
		'max'    => 4,
		'step'   => 1,
		'suffix' => 'px', //optional suffix
  	),
	)));
	
	$wp_customize->add_setting( 'explora_options[autoplay]', array(
            'default'=>$explora_theme_options['autoplay'],
            'sanitize_callback'=>'explora_sanitize_checkbox',
            'capability'        => 'edit_theme_options',
        )
    );
    $wp_customize->add_control( 'autoplay', array(
        'label'        => __( 'Blog AutoPlay', 'explora' ),
        'description' => 'blog autoplay on/off',
        'type'=>'checkbox',
        'section'    => 'explora_blog_section',
        'settings'   => 'explora_options[autoplay]',
    ) );
	
	$wp_customize->add_setting( 'explora_options[read_more]', array(
            'default'=>$explora_theme_options['read_more'],
            'sanitize_callback'=>'explora_sanitize_text',
            'capability'        => 'edit_theme_options',
        )
    );
    $wp_customize->add_control( 'read_more', array(
        'label'        => __( 'Blog Read More Button', 'explora' ),
        'description' => 'Enter Read More button text',
        'type'=>'text',
        'section'    => 'explora_blog_section',
        'settings'   => 'explora_options[read_more]',
    ) );
	
	$wp_customize->add_setting('explora_options[blog_category]',
		array(
			'sanitize_callback'=>'explora_sanitize_text',
			'capability' => 'edit_theme_options',
		)
	);
	
	$wp_customize->add_control(new explora_category_Control1( $wp_customize, 'blog_category', array(
		'label'        => __( 'Blog Category', 'explora' ),
		'type'=>'select',
		'section'    => 'explora_blog_section',
		'settings'   => 'explora_options[blog_category]',
	) ) );
	
	
	// For Home Search Section
	$wp_customize->add_section('search_section',array(
	'title'=>__("Home Search Options",'explora'),
	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));
	
	$wp_customize->add_setting( 'explora_options[search_form]', array(
            'default'=>$explora_theme_options['search_form'],
            'sanitize_callback'=>'explora_sanitize_checkbox',
            'capability'        => 'edit_theme_options',
        )
    );
    $wp_customize->add_control( 'search_form', array(
        'label'        => __( 'Enable search Form For header', 'explora' ),
        'description' => 'search',
        'type'=>'checkbox',
        'section'    => 'search_section',
        'settings'   => 'explora_options[search_form]',
    ) );
	
	// Social section
    $wp_customize->add_section('explora_social_section',array(
	'title'=>__(" Social Options",'explora'),
	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));
	
	$wp_customize->add_setting('explora_options[explora_social_media]', array(
		'default'=>esc_attr($explora_theme_options['explora_social_media']),
		'sanitize_callback'=>'explora_sanitize_checkbox',
		'capability'=>'edit_theme_options'
		));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_social_media]', array(
	'selector' => '.explora_social_media_head',
	'render_callback' => 'explora_options[explora_social_media]',
	) );
	$wp_customize->add_control( 'explora_social_media', array(
		'label'        => __( 'Enable Social Media Icons in Header', 'explora' ),
		'description'=>esc_html__('Select this option to show social icons on header', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[explora_social_media]'
	) );
	$wp_customize->add_setting(
	'explora_options[explora_footer_social_media]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_footer_social_media']),
		'sanitize_callback'=>'explora_sanitize_checkbox',
		'capability'=>'edit_theme_options'
		));
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_footer_social_media]', array(
	'selector' => '.explora_social_media_footer',
	'render_callback' => 'explora_options[explora_footer_social_media]',
	) );
	$wp_customize->add_control( 'explora_footer_social_media', array(
		'label'        => __( 'Enable Social Media Icons in Footer', 'explora' ),
		'description'=>esc_html__('Select this option to show social icons on footer', 'explora' ),
		'type'=>'checkbox',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[explora_footer_social_media]'
	) );
	
	$wp_customize->add_setting(
	'explora_options[facbook_link]',
		array(
		'default'=>esc_attr($explora_theme_options['facbook_link']),
		'sanitize_callback'=>'esc_url_raw',
		'capability'=>'edit_theme_options'
		));
	
	$wp_customize->add_control('facbook_link',
        array(
			'label'        => __( 'Facebook', 'explora' ),
			'description'=>esc_html__('Enter link address for facebook', 'explora' ),
			'type'=>'url',
            'section'  => 'explora_social_section',
			'settings'   => 'explora_options[facbook_link]'
    ));
	
	
	$wp_customize->add_setting(
	'explora_options[twitter_link]',
		array(
		'default'=>esc_attr($explora_theme_options['twitter_link']),
		'sanitize_callback'=>'esc_url_raw',
		'capability'=>'edit_theme_options'
		));
		$wp_customize->add_control( 'twitter_link', array(
		'label'        => __( 'Twitter', 'explora' ),
		'description'=>esc_html__('Enter link address for twitter', 'explora' ),
		'type'=>'url',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[twitter_link]'
	));
	
	$wp_customize->add_setting(
	'explora_options[youtube_link]',
		array(
		'default'=>esc_attr($explora_theme_options['youtube_link']),
		'sanitize_callback'=>'esc_url_raw',
		'capability'=>'edit_theme_options'
		)
	);
		$wp_customize->add_control( 'youtube_link', array(
		'label'        => __( 'Youtube', 'explora' ),
		'description'=>esc_html__('Enter link address for youtube', 'explora' ),
		'type'=>'url',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[youtube_link]'
	));
	$wp_customize->add_setting(
	'explora_options[linkdin_link]',
		array(
		'default'=>esc_attr($explora_theme_options['linkdin_link']),
		'sanitize_callback'=>'esc_url_raw',
		'capability'=>'edit_theme_options'
	));
	$wp_customize->add_control( 'linkdin_link', array(
		'label'        => __( 'Linkedin', 'explora' ),
		'description'=>esc_html__('Enter link address for linkdin', 'explora' ),
		'type'=>'url',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[linkdin_link]'
	));
	$wp_customize->add_setting(
	'explora_options[goglpls_link]',
		array(
		'default'=>esc_attr($explora_theme_options['goglpls_link']),
		'sanitize_callback'=>'esc_url_raw',
		'capability'=>'edit_theme_options'
	));
	$wp_customize->add_control( 'goglpls_link', array(
		'label'        => __( 'Google Plus', 'explora' ),
		'description'=>esc_html__('Enter link address for Google Plus', 'explora' ),
		'type'=>'url',
		'section'    => 'explora_social_section',
		'settings'   => 'explora_options[goglpls_link]'
	));
	
	// Footer Section
	$wp_customize->add_section('footer_section',array(
	'title'=>__("Footer Options",'explora'),
	'panel'=>'explora_theme_option',
	'capability'=>'edit_theme_options',
    'priority' => 35
	));	
	$wp_customize->add_setting(
	'explora_options[explora_footer_text]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_footer_text']),
		'sanitize_callback'=>'explora_sanitize_text',
		'capability'=>'edit_theme_options'
		)
	);
	$wp_customize->selective_refresh->add_partial( 'explora_options[explora_footer_text]', array(
	'selector' => '.explora_footer_text',
	'render_callback' => 'explora_options[explora_footer_text]',
	));
	$wp_customize->add_control( 'explora_footer_text', array(
		'label'        => __( 'Developed By Text', 'explora' ),
		'description'=>esc_html__('Enter footer text', 'explora' ),
		'type'=>'text',
		'section'    => 'footer_section',
		'settings'   => 'explora_options[explora_footer_text]'
	));
	$wp_customize->add_setting(
	'explora_options[explora_footer_link_text]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_footer_link_text']),
		'sanitize_callback'=>'explora_sanitize_text',
		'capability'=>'edit_theme_options'
	));
	$wp_customize->add_control( 'explora_footer_link_text', array(
		'label'        => __( 'Footer Customization Text', 'explora' ),
		'description'=>esc_html__('Enter link text for footer', 'explora' ),
		'type'=>'text',
		'section'    => 'footer_section',
		'settings'   => 'explora_options[explora_footer_link_text]'
	));
	$wp_customize->add_setting(
	'explora_options[explora_footer_link]',
		array(
		'default'=>esc_attr($explora_theme_options['explora_footer_link']),
		'capability'=>'edit_theme_options',
		'sanitize_callback'=>'esc_url_raw'
	));
	$wp_customize->add_control( 'explora_footer_link', array(
		'label'        => __( 'Developed By Link', 'explora' ),
		'description'=>esc_html__('Enter link for footer', 'explora' ),
		'type'=>'url',
		'section'    => 'footer_section',
		'settings'   => 'explora_options[explora_footer_link]'
	));  

	// home layout //
	$wp_customize->add_section('Home_Page_Layout',array(
    'title'=>__("Home Page Layout Option",'explora'),
    'panel'=>'explora_theme_option',
    'capability'=>'edit_theme_options',
    'priority' => 37,
    ));
	$wp_customize->add_setting('home_reorder',
            array(
				'type'=>'theme_mod',
                'sanitize_callback' => 'sanitize_json_string',
				'capability'        => 'edit_theme_options',
            )
        );
    $wp_customize->add_control(new explora_Custom_sortable_Control($wp_customize,'home_reorder', array(
		'label'=>__( 'Front Page Layout Option', 'explora' ),
        'section' => 'Home_Page_Layout',
        'type'    => 'home-sortable',
        'choices' => array(
            'services'      => __('Home Services', 'explora'),
            'portfolio'     => __('Home Portfolio', 'explora'),
            'blog'        => __('Home Blog', 'explora'),
        ),
		'settings'=>'home_reorder',
    )));
	// home layout close //
	$wp_customize->add_section( 'explora_more' , array(
		'title'      	=> __( 'Upgrade to Explora Premium -30%OFF', 'explora' ),
		'priority'   	=> 999,
		'panel'=>'explora_theme_option',
	));

	$wp_customize->add_setting( 'explora_more', array(
		'default'    		=> null,
		'sanitize_callback' => 'sanitize_text_field',
	));

	$wp_customize->add_control( new explora_More_Control( $wp_customize, 'explora_more', array(
		'label'    => __( 'Explora Premium', 'explora' ),
		'section'  => 'explora_more',
		'settings' => 'explora_more',
		'priority' => 1,
	)));
			
	//changelog//	
	$wp_customize->add_section('changelog_sec',	array('title' =>  __( 'Changelog','explora' ),
			'panel'=>'explora_theme_option',
            'priority' => 1,
    ));
	$wp_customize->add_setting( 'changelog', array(
			'default'    		=> null,
			'sanitize_callback' => 'sanitize_text_field',
	));
	$wp_customize->add_control( new explora_More_Control( $wp_customize, 'explora_more', array(
			'label'    => __( 'Explora Premium', 'explora' ),
			'section'  => 'explora_more',
			'settings' => 'explora_more',
			'priority' => 1,
	)));
}

function explora_sanitize_text( $input ) {
    return wp_kses_post( force_balance_tags( $input ) );
}
function explora_sanitize_checkbox( $input ) {
   if ( $input == 1 ) {
        return 'on' ;
    } else {
        return 'off';
    }
}
function explora_sanitize_integer( $input ) {
    return (int)($input);
}

function sanitize_json_string($json){
    $sanitized_value = array();
    foreach (json_decode($json,true) as $value) {
        $sanitized_value[] = esc_attr($value);
    }
    return json_encode($sanitized_value);
}

function themeslug_sanitize_select( $input, $setting ) {

  // Ensure input is a slug.
  $input = sanitize_key( $input );

  // Get list of choices from the control associated with the setting.
  $choices = $setting->manager->get_control( $setting->id )->choices;

  // If the input is a valid key, return it; otherwise, return the default.
  return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}

/* class for thumbnail images */
if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'Slider_Image_Control' ) ) :
class Slider_Image_Control extends WP_Customize_Control 
{   public function render_content(){ ?>
	<span class="customize-control-title"><?php echo $this->label; ?></span>
	<?php $args = array( 'post_type' => 'post','posts_per_page'=> -1, 'post_status'=>'publish',); 
		$explora_post = new WP_Query( $args ); ?>
		<select <?php $this->link(); ?> >
		<?php if($explora_post->have_posts()):
			while($explora_post->have_posts()):
				$explora_post->the_post();
				if(has_post_thumbnail()){ ?><option value= "<?php echo get_the_id(); ?>"<?php if($this->value()== get_the_id() ) echo 'selected="selected"';?>><?php the_title(); ?></option><?php }
			endwhile;
			wp_reset_postdata();
	     endif; ?>
		 </select>
		 <?php
}  /* public function ends */
}/*   class ends */
endif;

/* class for categories */
if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'explora_category_Control' ) ) :
class explora_category_Control extends WP_Customize_Control 
{   public function render_content(){ ?>
		<span class="customize-control-title"><?php echo $this->label; ?></span>
		<?php  $explora_category = get_categories(); ?>
		<select <?php $this->link(); ?> >
			<option value= "" <?php if($this->value()=='') echo 'selected="selected"';?>><?php esc_html_e('Default Image','explora'); ?></option>
			<?php foreach($explora_category as $category){ ?>
				<option value= "<?php echo $category->cat_name; ?>" <?php if($this->value()=='') echo 'selected="selected"';?> ><?php echo $category->cat_name; ?></option>
			<?php } ?>
		</select> <?php
	}  /* public function ends */
}/*   class ends */
endif; 

if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'explora_More_Control' ) ) :
class explora_More_Control extends WP_Customize_Control {

	/**
	* Render the content on the theme customizer page
	*/
	public function render_content() { ?>
			<div class="row">
		<div class="col-md-4">
				<div class="stitched"><?php _e("Coupon Code : HAPPYHOLI","explora") ;?>	</div>
		
		
		
		</div>
		</div>
		<label style="overflow: hidden; zoom: 1;">
			<div class="col-md-2 col-sm-6 upsell-btn">					
					<a style="margin-bottom:20px;margin-left:20px;" href="https://weblizar.com/themes/explora-premium/" target="blank" class="btn btn-success btn"><?php _e('Upgrade to Explora Premium','explora'); ?> </a>
			</div>
			<div class="col-md-4 col-sm-6">
				<img class="enigma_img_responsive " src="<?php echo get_template_directory_uri().'/images/Explora-Responsive.jpg';?>">
			</div>			
			<div class="col-md-3 col-sm-6">
				<h3 style="margin-top:10px;margin-left: 20px;text-decoration:underline;color:#333;"><?php echo _e( 'Explora Premium-Features','explora'); ?></h3>
					<ul style="padding-top:20px">
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Fully Responsive Designs','explora'); ?> </li>						
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Unlimited Color Scheme','explora'); ?> </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Easy Customizartzed Option Panel','explora'); ?> </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Multiple Template','explora'); ?></li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Woo Commerce Ready Theme','explora'); ?></li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('WPML Compatible','explora'); ?>   </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('HTML 5 & Css3','explora'); ?>   </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Coming Soon Mode','explora'); ?>	
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Theme Option Panel','explora'); ?> </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Shortcode','explora'); ?> </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Customs Widgets','explora'); ?> </li>
						<li class="upsell-enigma"> <div class="dashicons dashicons-yes"></div> <?php _e('Box Layout','explora'); ?>  </li>
					
					</ul>
			</div>
			<div class="col-md-2 col-sm-6 upsell-btn">					
					<a style="margin-bottom:20px;margin-left:20px;" href="https://weblizar.com/themes/explora-premium/" target="blank" class="btn btn-success btn"><?php _e('Upgrade to Explora Premium','explora'); ?> </a>
			</div>
			<span class="customize-control-title"><?php _e( 'Enjoying Explora?', 'explora' ); ?></span>
			<p>
				<?php
					printf( __( 'If you Like our Products , Please do Rate us on %sWordPress.org%s?  We\'d really appreciate it!', 'explora' ), '<a target="" href="https://wordpress.org/support/view/theme-reviews/explora?filter=5">', '</a>' );
				?>
			</p>
		</label>
		<?php
	}
}
endif;

if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'explora_Custom_sortable_Control' ) ) :
class explora_Custom_sortable_Control extends WP_Customize_Control
{
    public $type = 'home-sortable';
    /*Enqueue resources for the control*/
    public function enqueue()
    {

        wp_enqueue_style('customizer-repeater-admin-stylesheet', get_template_directory_uri() . '/assets/customizer_js_css/css/explora-admin-style.css', time());

        wp_enqueue_script('customizer-repeater-script', get_template_directory_uri() . '/assets/customizer_js_css/js/explora-customizer_repeater.js', array('jquery', 'jquery-ui-draggable'), time(), true);

    }
    public function render_content()
    {
        if (empty($this->choices)) {
            return;
        }
        $values = json_decode($this->value());
        $name         = $this->id;
        ?>

		<span class="customize-control-title">
			<?php echo esc_attr($this->label); ?>
		</span>

		<?php if (!empty($this->description)): ?>
			<span class="description customize-control-description"><?php echo esc_html($this->description); ?></span>
		<?php endif;?>

		<div class="customizer-repeater-general-control-repeater customizer-repeater-general-control-droppable">
			<?php 
			if(!empty($values)){ 
				foreach ($values as $value) {?>
					<div class="customizer-repeater-general-control-repeater-container customizer-repeater-draggable ui-sortable-handle">
					<div class="customizer-repeater-customize-control-title">
						<?php echo $this->choices[$value]; ?>
					</div>
					<input type="hidden" class="section-id" value="<?php echo $value; ?>">
					</div>	
				<?php }?>
				
			<?php }else{
			foreach ($this->choices as $value => $label): ?>
					<div class="customizer-repeater-general-control-repeater-container customizer-repeater-draggable ui-sortable-handle">
					<div class="customizer-repeater-customize-control-title">
						<?php echo $label; ?>
					</div>
					<input type="hidden" class="section-id" value="<?php echo $value; ?>">
					</div>

				<?php endforeach;
			}
        		if (!empty($value)) {?>
					<input type="hidden"
					       id="customizer-repeater-<?php echo $this->id; ?>-colector" <?php esc_url($this->link());?>
					       class="customizer-repeater-colector"
					       value="<?php echo esc_textarea(json_encode($value)); ?>"/>
					<?php
				} else {?>
					<input type="hidden"
					       id="customizer-repeater-<?php echo $this->id; ?>-colector" <?php esc_url($this->link());?>
					       class="customizer-repeater-colector"/>
					<?php
				}?>
		</div>
		<?php
}
}
endif;

if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'explora_changelog_Control' ) ) :
class explora_changelog_Control extends WP_Customize_Control {

	/**
	* Render the content on the theme customizer page
	*/
	public function render_content() { ?>
		<label style="overflow: hidden; zoom: 1;">
						
			<div class="col-md-3 col-sm-6">
				<h2 style="margin-top:10px;color:#fff;background-color: #f47749;padding: 10px;font-size: 19px;"><?php echo _e( 'Explora Theme Changelog','explora'); ?></h2>
					<ul style="padding-top:20px">
						<li class="upsell-enigma"> <div class="versionhd"> Version: 1.3- <span class="lastest-version">Current Version</span></div>
  <ol> <li>Added Icon Picker  </li><li>Added WP Editor  </li><li>Added Section Drag-Drop   </li><li>Added Star Rating banner</li><li>Quick Edit Path Locator</li></ol></li>
  <li class="upsell-enigma"> <div class="versionhd"> Version: 1.2.4 </div>
  <ol> <li>Upsell Link added </li></ol></li>				
						<li class="upsell-enigma"> <div class="versionhd"> Version: 1.2.3 - </div>
<ol> <li> Screenshot png image size manage.</li></ol> </li>
						<li class="upsell-enigma"> <div class="versionhd"> Version: 1.2.2 - </div>
<ol> <li> Fixed issue ticket url : https://themes.trac.wordpress.org/ticket/39783#comment:12 </li></ol></li>
						<li class="upsell-enigma"> <div class="versionhd"> Version: 1.2.1 - </div>
<ol> <li> Fixed issue ticket url : https://themes.trac.wordpress.org/ticket/39783#comment:9 </li></ol> </li>
						<li class="upsell-enigma">  <div class="versionhd"> Version: 1.2 - </div>
<ol> <li> Fixed issue ticket url : https://themes.trac.wordpress.org/ticket/39783#comment:7 </li></ol> </li>
						<li class="upsell-enigma">  <div class="versionhd"> Version: 1.1 - </div>
<ol> <li>Fixed issue ticket url : https://themes.trac.wordpress.org/ticket/39783#comment:4 </li>
<li>Screenshot change  </li></ol></li>
					</ul>
			</div>
			<div class="col-md-2 col-sm-6 upsell-btn">					
					<a style="margin-bottom:20px;margin-left:20px;" href="<?php echo esc_url(get_template_directory_uri()) ?>/changelog.txt" target="blank" class="btn btn-success btn"><?php _e('Changelog','explora'); ?> </a>
			</div>
		</label>
		<?php
	}
}
endif;

if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'Customizer_Range_Value_Control' ) ) :
class Customizer_Range_Value_Control extends WP_Customize_Control {
	public $type = 'range-value';
	
	 // Enqueue scripts/styles.

	public function enqueue() {
		wp_enqueue_script( 'customizer-range-value-control', get_stylesheet_directory_uri() . '/js/customizer-range-value-control.js', array( 'jquery' ), rand(), true );
		wp_enqueue_style( 'customizer-range-value-control', get_stylesheet_directory_uri() . '/css/customizer-range-value-control.css', array(), rand() );
	}
	
	 
	public function render_content() {
		?>
		<label>
			<span class="customize-control-title"><?php echo esc_html( $this->label ); ?></span>
			<div class="range-slider"  style="width:100%; display:flex;flex-direction: row;justify-content: flex-start;">
				<span  style="width:100%; flex: 1 0 0; vertical-align: middle;"><input class="range-slider__range" type="range" value="<?php echo esc_attr( $this->value() ); ?>" <?php $this->input_attrs(); $this->link(); ?>>
				<span class="range-slider__value">0</span></span>
			</div>
			<?php if ( ! empty( $this->description ) ) : ?>
			<span class="description customize-control-description"><?php echo $this->description; ?></span>
			<?php endif; ?>
		</label>
		<?php
	}
}
endif;

/* class for categories */
if ( class_exists( 'WP_Customize_Control' ) && ! class_exists( 'explora_category_Control1' ) ) :
class explora_category_Control1 extends WP_Customize_Control 
{   public function render_content(){ ?>
		<span class="customize-control-title"><?php echo $this->label; ?></span>
		<?php  $enigma_category = get_categories(); ?>
		<select <?php $this->link(); ?> >
			<?php foreach($enigma_category as $category){ ?>
				<option value= "<?php echo $category->term_id; ?>" <?php if($this->value()=='') echo 'selected="selected"';?> ><?php echo $category->cat_name; ?></option>
			<?php } ?>
		</select> <?php
	}  /* public function ends */
}/*   class ends */
endif;
?>